<template>
  <div class="parameter">
    <div class="parameter__section">
      <h2 class="parameter__section__title">
        Choose a nickname and a category
      </h2>
      <ul class="list_errors" v-if="errors.length">
        <li v-for="error in errors" v-bind:key="error.id">{{ error.msg }}</li>
      </ul>
      <form @submit="checkForm($event)" class="parameter__section_form">
        <div class="parameter__section__form__container">
          <label class="parameter__section_form__label" for="nickname"
            >Nickname</label
          >
          <input
            placeholder="Enter a nickname"
            class="parameter__section_form__input"
            id="nickname"
            v-model="nickname"
            name="nickname"
          />
        </div>
        <div class="parameter__section__form__container">
          <label class="parameter__section_form__label" for="category"
            >Category</label
          >
          <select
            class="parameter__section_form__input"
            id="category"
            v-model="category"
          >
            <option value="">--Choose a category--</option>
            <option value="9">General Knowledge</option>
            <option value="10">Books</option>
            <option value="11">Films</option>
            <option value="12">Music</option>
            <option value="13">Theatres</option>
            <option value="14">Television</option>
            <option value="15">Video Games</option>
            <option value="16">Board Games</option>
            <option value="17">Science</option>
            <option value="18">Computers</option>
            <option value="20">Mythology</option>
            <option value="21">Sports</option>
            <option value="22">Geography</option>
            <option value="23">History</option>
            <option value="24">Politics</option>
            <option value="25">Arts</option>
            <option value="26">Celebrities</option>
            <option value="27">Animals</option>
            <option value="28">Vehicules</option>
          </select>
        </div>
        <div class="parameter__section__form__container">
          <label class="parameter__section_form__label" for="difficulty"
            >Difficulty</label
          >
          <select
            class="parameter__section_form__input"
            id="difficulty"
            v-model="difficulty"
          >
            <option value="">--Choose a difficulty--</option>
            <option value="easy">Easy</option>
            <option value="medium">Medium</option>
            <option value="hard">Hard</option>
          </select>
        </div>
        <button type="submit" class="parameter__section_button button__home">
          Start
        </button>
      </form>
    </div>
  </div>
</template>
<script lang="ts">
import Vue from "vue";
import axios from "axios";
export default Vue.extend({
  name: "form",
  data(): {
    nickname: string;
    category: string;
    difficulty: string;
    errors: { id: number; msg: string }[];
  } {
    return {
      nickname: "",
      category: "",
      difficulty: "",
      errors: []
    };
  },
  methods: {
    // We check that the form fulfills all the validation conditions
    checkForm(event: MouseEvent) {
      event.preventDefault();
      this.errors = [];
      this.nickname = this.nickname.trim();
      if (!this.nickname) {
        this.errors.push({ id: 1, msg: "Please enter a username" });
      }
      if (this.nickname.length >= 9) {
        this.errors.push({
          id: 2,
          msg: "Username can not be longer than 9 characters"
        });
      }
      if (!this.category) {
        this.errors.push({ id: 3, msg: "Please select a category" });
      }
      if (!this.difficulty) {
        this.errors.push({ id: 4, msg: "Please choose a difficulty" });
      }
      if (
        this.nickname &&
        this.nickname.length <= 9 &&
        this.category &&
        this.difficulty
      ) {
        this.$router.push({
          name: "quizz",
          params: {
            infoPlayer: {
              nickname: this.nickname,
              category: this.category,
              difficulty: this.difficulty
            }
          }
        });
      }
    }
  }
});
</script>

<style>
.parameter {
  height: 100%;
}
.parameter__section {
  margin: 20px;
  height: 100%;
  display: flex;
  flex-direction: column;
  align-items: center;
  justify-content: flex-start;
}
.parameter__section__title {
  font-size: 26px;
  line-height: 140%;
  font-weight: bold;
  color: #454e5b;
  margin-bottom: 15px;
}
.parameter__section_form {
  height: 60%;
  width: 100%;
}
.parameter__section_form__input {
  background-color: #fdfdff;
  border: 1px solid #f0f0f2;
  border-radius: 7px;
  height: 38px;
  font-size: 100%;
}
.parameter__section_form__input::placeholder,
.parameter__section_form__input option {
  font-size: 17px;
}
.parameter__section__form__container {
  display: flex;
  flex-direction: column;
  align-content: flex-start;
  justify-content: space-around;
  height: 30%;
  width: 100%;
  margin-top: 5%;
}
.parameter__section__form__container label {
  font-size: 20px;
  margin: 15px 0;
}
.parameter__section_button {
  margin-top: 10%;
}
.list_errors {
  width: 100%;
  padding: 0;
}
.list_errors li {
  list-style: none;
  width: 100%;
  margin-top: 13px;
  text-align: center;
  color: #ff00008a;
  font-weight: bold;
}
</style>
